using UnityEngine;
using System.Collections;

public class CubeMovement : MonoBehaviour {
	public bool isServer;
	
	public CubeMovement () {
		isServer = true;
	}
	
	// Use this for initialization
	void Start () {
	}
	
	// Update is called once per frame
	void Update () {
		if (Input.GetKey(KeyCode.UpArrow) && isServer == Network.isServer) {
			transform.position += Vector3.up * Time.deltaTime;
		}
	}
	
	void OnNetworkInstantiate(NetworkMessageInfo info) {
		Debug.Log(info.sender.ToString());
    }
	
	void OnSerializeNetworkView(BitStream stream, NetworkMessageInfo info) {
        if (stream.isWriting) {
			Vector3 pos = transform.position;
			stream.Serialize(ref pos);
        } else {
			Vector3 pos = new Vector3();
            stream.Serialize(ref pos);
            transform.position = pos;
        }
	}
	
	[RPC]
	void setToClient () {
		Debug.Log("setToClient Called");
		isServer = false;
		Debug.Log("isServer: " + isServer.ToString());
	}
	
	[RPC]
	void setToServer () {
		Debug.Log("setToServer Called");
		isServer = true;
		Debug.Log("isServer: " + isServer.ToString());
	}
}
